{ Se puede cambiar perfectamente el acceso directo a memoria de video
por los BGIs ( Borlang Graphics Interface ), para gastar menos memoria
o para hacer un entorno ms acogedor :-)). Solo hay que cambiar el PutDot
por el putpixel, aunque ir un poco ms lento :-((.}
Program Scope;

uses
  Crt;

const
  ResetPort    = $226;
  CommandPort  = $22C;
  ReadPort     = $22A;
  PollPort     = $22E;
  MaxOldDots   = 50000;  { tamao mximo del array }
  MixerRegPort = $224;
  MixerDatPort = $225;
  Master       = 1;         { Estas constantes se pueden utilizar }
  Line         = 46;        { Para el programa completo }
  VOC          = 21;        { Para graduar el volumen de entrada }
  FM           = 23;        { El volumen desalida }
  CD           = 25;        { Desde y hasta la tarjeta de sonido }
  Mic          = 27;        {                                    }
  ADCChannel   = 29;
  StereoSell   = 31;     { 0,1 = mono; 2,3 = stereo }
  Microfono    = 1;      { Especifica la entrada de audio, }
  LineIn       = 6;      { micrfono o entrada de lnea }

var
  Scr       : array [0..199, 0..319] of byte absolute $A000:0000; { Pantalla virtual para presentar la onda }
  Ch        : char;       { Para esperar que se pulse una tecla }
  XInt,
  XWidth,
  XMax,
  YMax,
  XMid,
  YMid,
  MaxHeight,
  XStart,
  Color,
  ColorBack : integer;  { Variables de la posicin del punto para formar la onda }
  OldDots   : array [0..MaxOldDots] of byte;  { para restaurar los puntos anteriores }

Procedure InitVideo(Mode : byte; Clr : boolean); { Inicializa modo de video a 320x200x256 }
begin
  if NOT Clr then
    Mode := Mode + 128;
  ASM
    mov AH, 00
    mov AL, Mode
    int 10h
  end;
end;

Procedure PutDot(x, y : word; Color : byte); { Pone un punto en la pantalla virtual }
begin
  Scr[y, x] := Color;
end;

Procedure SquareFill(x1, y1, x2, y2 : word; Color : byte); { Pone la pantalla a punto, el cuadrado }
var
  y : word;
begin
  for y := y1 to y2 do
    FillChar(Scr[y, x1], x2-x1, Color);
end;

{ Los siguientes procedimientos "resetean" la tarjeta de sonido, ajusta el puerto, etc...}
Procedure SetMixer(PortNum, Vol : byte);
begin
  asm
    MOV DX, MixerRegPort
    MOV AL, PortNum
    OUT DX, AL
    MOV DX, MixerDatPort
    MOV AL, Vol
    OUT DX, AL
  end;
end;

Function ResetSB : boolean;
begin
  Port[ResetPort] := 1;
  Delay(1);
  Port[ResetPort] := 0;
  Delay(1);
  if Port[PollPort] and 128 = 128 then
    ResetSB := True
  else
    ResetSB := False;
end;
{}
Procedure ShowDots(D : integer); { Muestra los puntos de la onda }
var
  x, y : word;
  NewX : word;
begin
  for x := 1 to XWidth * d do
  begin
    port[CommandPort] := $20;                     { Estas lneas toman }
    repeat until (port[PollPort] and 128 = 128);  { la informacin de }
    y := port[ReadPort];                          { la tarjeta }

    if y > 128 + MaxHeight then
      y := 128 + MaxHeight;
    if y < 128 - MaxHeight then
      y := 128 - MaxHeight;

    NewX := x div d;
    PutDot(NewX + XStart-1, OldDots[x] + YMid - 128, ColorBack);
    PutDot(NewX + XStart-1, y + YMid - 128, y div 2);
    OldDots[x] := y;
  end;
  if keypressed then
  begin                  { Cuando se pulsa Intro se }
    Ch := ReadKey;       { Establece una pausa }
    if Ch = #13 then           { Y cuando se pulsa otra tecla }
      repeat until keypressed; { Se quita la pausa }
  end;
end;

Procedure Init;    { Initializa todas las variables }
var
  N : longint;
begin
  InitVideo($13, TRUE);
  Ch        := #0;
  XMax      := 319;
  XMid      := XMax div 2;
  YMax      := 199;
  YMid      := YMax div 2;
  XInt      := 10;
  XWidth    := 280;
  XStart    := XMid - XWidth div 2;
  MaxHeight := 60;
  Color     := 9;
  ColorBack := 0;
  SquareFill(XStart-10, YMid-MaxHeight-1-10, XStart+XWidth+1+10, YMid+MaxHeight+1+10, 10);
  SquareFill(XStart, YMid-MaxHeight-1, XStart+XWidth+1, YMid+MaxHeight+1, ColorBack);
  for N := 0 to MaxOldDots do
    OldDots[N] := 128;
  if ResetSb then;
end;

BEGIN
  Init;
  SetMixer(ADCChannel, Microfono);
  While Ch <> #27 do ShowDots(1);  { Muestra la onda hasta que se pulse Esc. }
  initvideo($3,FALSE);
END.
